
require 'ostruct'

class Hash

  # Like to_ostruct but recusively objectifies all hash elements as well.
  #
  #   o = { 'a' => { 'b' => 1 } }.to_ostruct_recurse
  #   o.a.b  #=> 1
  #
  def to_ostruct_recurse
    o = self.dup
    each_pair do |k,v|
      o[k] = v.to_ostruct_recurse if v.respond_to?( :to_ostruct_recurse )
    end
    ::OpenStruct.new( o )
  end

end



#  _____         _
# |_   _|__  ___| |_
#   | |/ _ \/ __| __|
#   | |  __/\__ \ |_
#   |_|\___||___/\__|
#
=begin test

  require 'test/unit'

  class TCHash < Test::Unit::TestCase

    def test_to_ostruct_recurse
      a = { :a => 1, :b => 2, :c => { :x => 4 } }
      ao = a.to_ostruct_recurse
      assert_equal(  a[:a], ao.a )
      assert_equal(  a[:b], ao.b )
      assert_equal(  a[:c][:x], ao.c.x )
    end

  end

=end
