class Module

  # Returns the root name of the module/class.
  #
  #   module Example
  #     class Demo
  #     end
  #   end
  #
  #   Demo.name       #=> Example::Demo
  #   Demo.basename   #=> Demo
  #
  def basename
    self.name.gsub(/^.*::/, '')
  end

end



#  _____         _
# |_   _|__  ___| |_
#   | |/ _ \/ __| __|
#   | |  __/\__ \ |_
#   |_|\___||___/\__|
#
=begin test

  require 'test/unit'

  class TCModule < Test::Unit::TestCase

    def test_basename
      assert_equal( "TestCase", ::Test::Unit::TestCase.basename )
    end

  end

=end
